package dev.inmo.postssystem.business_cases.post_creating.client

import dev.inmo.postssystem.business_cases.post_creating.server.*
import dev.inmo.postssystem.core.content.Content
import dev.inmo.postssystem.core.post.RegisteredPost
import dev.inmo.postssystem.core.publishing.TriggerId
import dev.inmo.micro_utils.ktor.client.BodyPair
import dev.inmo.micro_utils.ktor.client.unipost
import dev.inmo.micro_utils.ktor.common.buildStandardUrl
import io.ktor.client.HttpClient

class PostCreatingClientCase(
    private val baseUrl: String,
    private val client: HttpClient
) : PostCreatingCase {
    private val realBaseUrl = "$baseUrl/$postCreatingRootRoute"
    override suspend fun createPost(postContent: List<Content>, triggerId: TriggerId?): RegisteredPost? = client.unipost(
        buildStandardUrl(realBaseUrl, postCreatingCreatePostRoute),
        BodyPair(PostCreatingCreatePostModel.serializer(), PostCreatingCreatePostModel(postContent, triggerId)),
        RegisteredPost.serializer()
    )
}
