package dev.inmo.postssystem.business_cases.post_creating.server

import dev.inmo.postssystem.core.content.Content
import dev.inmo.postssystem.core.post.RegisteredPost
import dev.inmo.postssystem.core.publishing.TriggerId
import kotlinx.serialization.Serializable

@Serializable
data class PostCreatingCreatePostModel(
    val postContent: List<Content>,
    val triggerId: TriggerId?
)

interface PostCreatingCase {
    suspend fun createPost(
        postContent: List<Content>,
        triggerId: TriggerId? = null
    ): RegisteredPost?
}