package dev.inmo.postssystem.core.content.api

import dev.inmo.postssystem.core.content.ContentId
import dev.inmo.postssystem.core.content.RegisteredContent
import dev.inmo.micro_utils.pagination.Pagination
import dev.inmo.micro_utils.pagination.PaginationResult

/**
 * Simple read API by different properties of [dev.inmo.postssystem.core.content.Content].
 */
interface ReadContentRepo {
    /**
     * @return [Set] of [ContentId] wich currently known in this instance of API
     */
    suspend fun getContentsIds(): Set<ContentId>
    /**
     * @return [RegisteredContent] if it is available by [id]
     */
    suspend fun getContentById(id: ContentId): RegisteredContent?

    /**
     * @return all [RegisteredContent] by pages basing on their creation date
     */
    suspend fun getContentByPagination(pagination: Pagination): PaginationResult<RegisteredContent>
}