package dev.inmo.postssystem.core.content.api

import dev.inmo.postssystem.core.content.*
import kotlinx.coroutines.flow.Flow

interface WriteContentRepo {
    val contentCreatedFlow: Flow<RegisteredContent>
    val contentDeletedFlow: Flow<RegisteredContent>

    suspend fun registerContent(content: Content): RegisteredContent?
    suspend fun deleteContent(id: ContentId): Boolean
}
