package dev.inmo.postssystem.core.post

import dev.inmo.postssystem.core.post.repo.PostsRepo

class BusinessPublishablePostsRepo(
    /**
     * Will be used for storing of unpublished data
     */
    private val repoPostsRepo: PostsRepo,
    /**
     * Will be used to send information ab
     */
    private val publishedPostsRepo: PostsRepo
) : PostsRepo by repoPostsRepo {
    override suspend fun deletePost(id: PostId): Boolean {
        return getPostById(id) ?.let { post ->
            publishedPostsRepo.createPost(post)
            repoPostsRepo.deletePost(id)
        } ?: return false
    }
}