package dev.inmo.postssystem.core.ktor.client.content

import dev.inmo.postssystem.core.content.api.*
import dev.inmo.postssystem.core.ktor.contentRootRoute
import io.ktor.client.HttpClient
import io.ktor.client.features.websocket.WebSockets

class ContentRepoKtorClient private constructor(
    readContentRepo: ReadContentRepo,
    writeContentRepo: WriteContentRepo
) : ContentRepo, ReadContentRepo by readContentRepo, WriteContentRepo by writeContentRepo {
    constructor(
        baseUrl: String,
        client: HttpClient = HttpClient {
            install(WebSockets)
        }
    ) : this(
        ReadContentRepoKtorClient(
            "$baseUrl/$contentRootRoute",
            client
        ),
        WriteContentRepoKtorClient(
            "$baseUrl/$contentRootRoute",
            client
        )
    )
}
