package dev.inmo.postssystem.core.ktor.server.post

import dev.inmo.postssystem.core.ktor.postsRootRoute
import dev.inmo.postssystem.core.post.repo.PostsRepo
import dev.inmo.micro_utils.ktor.server.configurators.ApplicationRoutingConfigurator
import io.ktor.routing.Route
import io.ktor.routing.route

fun Route.configurePostsRepoRoutes(
    proxyTo: PostsRepo
) {
    route(postsRootRoute) {
        configureReadPostsRepoRoutes(proxyTo)
        configureWritePostsRepoRoutes(proxyTo)
    }
}

class PostsRepoRoutingConfigurator(
    private val proxyTo: PostsRepo
) : ApplicationRoutingConfigurator.Element {
    override fun Route.invoke() {
        configurePostsRepoRoutes(proxyTo)
    }
}
