package dev.inmo.postssystem.core.publishing.repos

import dev.inmo.postssystem.core.post.PostId
import dev.inmo.postssystem.core.publishing.TriggerControlKey

interface ReadPublishingKeysRepo {
    suspend fun getPostIdByTriggerControlKey(
        key: TriggerControlKey
    ): PostId?
    suspend fun getTriggerControlKeyByPostId(
        postId: PostId
    ): TriggerControlKey?
}

interface WritePublishingKeysRepo {
    suspend fun setPostTriggerControlKey(
        postId: PostId,
        key: TriggerControlKey
    ): Boolean
    suspend fun unsetPostTriggerControlKey(
        postId: PostId
    ): Boolean
}

interface PublishingKeysRepo : ReadPublishingKeysRepo, WritePublishingKeysRepo
