package dev.inmo.postssystem.publishing.ktor.client

import dev.inmo.postssystem.core.post.PostId
import dev.inmo.postssystem.core.publishing.TriggerControlKey
import dev.inmo.postssystem.core.publishing.repos.ReadPublishingKeysRepo
import dev.inmo.postssystem.publishing.ktor.getPostIdByTriggerControlKeyRoute
import dev.inmo.postssystem.publishing.ktor.getTriggerControlKeyByPostIdRoute
import dev.inmo.micro_utils.ktor.client.uniget
import dev.inmo.micro_utils.ktor.common.buildStandardUrl
import io.ktor.client.HttpClient
import kotlinx.serialization.builtins.nullable
import kotlinx.serialization.builtins.serializer

class ReadPublishingKeysRepoKtorClient (
    private val baseUrl: String,
    private val client: HttpClient = HttpClient()
) : ReadPublishingKeysRepo {
    override suspend fun getPostIdByTriggerControlKey(key: TriggerControlKey): PostId? = client.uniget(
        buildStandardUrl(baseUrl, "$getPostIdByTriggerControlKeyRoute/$key"),
        PostId.serializer().nullable
    )

    override suspend fun getTriggerControlKeyByPostId(postId: PostId): TriggerControlKey? = client.uniget(
        buildStandardUrl(baseUrl, "$getTriggerControlKeyByPostIdRoute/$postId"),
        TriggerControlKey.serializer().nullable
    )
}