package dev.inmo.postssystem.publishing.ktor.client

import dev.inmo.postssystem.core.post.PostId
import dev.inmo.postssystem.core.publishing.TriggerControlKey
import dev.inmo.postssystem.core.publishing.repos.WritePublishingKeysRepo
import dev.inmo.postssystem.publishing.ktor.*
import dev.inmo.micro_utils.ktor.client.BodyPair
import dev.inmo.micro_utils.ktor.client.unipost
import dev.inmo.micro_utils.ktor.common.buildStandardUrl
import io.ktor.client.HttpClient
import kotlinx.serialization.builtins.serializer

class WritePublishingKeysRepoKtorClient (
    private val baseUrl: String,
    private val client: HttpClient = HttpClient()
) : WritePublishingKeysRepo {
    override suspend fun setPostTriggerControlKey(postId: PostId, key: TriggerControlKey): Boolean = client.unipost(
        buildStandardUrl(baseUrl, setPostTriggerControlKeyRoute),
        BodyPair(SetPostTriggerControlKeyObject.serializer(), SetPostTriggerControlKeyObject(postId, key)),
        Boolean.serializer()
    )

    override suspend fun unsetPostTriggerControlKey(postId: PostId): Boolean = client.unipost(
        buildStandardUrl(baseUrl, unsetPostTriggerControlKeyRoute),
        BodyPair(PostId.serializer(), postId),
        Boolean.serializer()
    )
}