package dev.inmo.postssystem.publishing.ktor.server

import dev.inmo.postssystem.core.publishing.repos.PublishingKeysRepo
import dev.inmo.postssystem.publishing.ktor.publishingKeysRootRoute
import dev.inmo.micro_utils.ktor.server.configurators.ApplicationRoutingConfigurator
import io.ktor.routing.Route
import io.ktor.routing.route

fun Route.configurePublishingKeysRepoRoutes (
    proxyTo: PublishingKeysRepo
) {
    route(publishingKeysRootRoute) {
        configureReadPublishingKeysRepoRoutes(proxyTo)
        configureWritePublishingKeysRepoRoutes(proxyTo)
    }
}

class PublishingKeysRepoRoutingConfigurator (
    private val proxyTo: PublishingKeysRepo
) : ApplicationRoutingConfigurator.Element {
    override fun Route.invoke() {
        configurePublishingKeysRepoRoutes(proxyTo)
    }
}